'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ReactMdeCommands = require('./ReactMdeCommands');

var _ReactMdeCommands2 = _interopRequireDefault(_ReactMdeCommands);

var _showdown = require('showdown');

var _showdown2 = _interopRequireDefault(_showdown);

var _HeaderGroup = require('./components/HeaderGroup');

var _HeaderGroup2 = _interopRequireDefault(_HeaderGroup);

var _HeaderItem = require('./components/HeaderItem');

var _HeaderItem2 = _interopRequireDefault(_HeaderItem);

var _HeaderItemDropdown = require('./components/HeaderItemDropdown');

var _HeaderItemDropdown2 = _interopRequireDefault(_HeaderItemDropdown);

var _HeaderItemDropdownItem = require('./components/HeaderItemDropdownItem');

var _HeaderItemDropdownItem2 = _interopRequireDefault(_HeaderItemDropdownItem);

var _MarkdownHelp = require('./components/MarkdownHelp');

var _MarkdownHelp2 = _interopRequireDefault(_MarkdownHelp);

var _ReactMdeSelectionHelper = require('./ReactMdeSelectionHelper');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ReactMde = function (_Component) {
    _inherits(ReactMde, _Component);

    function ReactMde() {
        _classCallCheck(this, ReactMde);

        var _this = _possibleConstructorReturn(this, (ReactMde.__proto__ || Object.getPrototypeOf(ReactMde)).call(this));

        _this.converter = new _showdown2.default.Converter();
        return _this;
    }

    /**
     * Handler for the textarea value change
     * @param {any} e
     * @memberOf ReactMde
     */


    _createClass(ReactMde, [{
        key: 'handleValueChange',
        value: function handleValueChange(e) {
            var _props = this.props,
                _props$value = _props.value,
                text = _props$value.text,
                selection = _props$value.selection,
                onChange = _props.onChange;

            onChange({ text: e.target.value, selection: null });
        }

        /**
         * Executes a command
         * @param {function} command
         * @memberOf ReactMde
         */

    }, {
        key: 'executeCommand',
        value: function executeCommand(command) {
            var _props2 = this.props,
                _props2$value = _props2.value,
                text = _props2$value.text,
                selection = _props2$value.selection,
                onChange = _props2.onChange;

            var textarea = this.refs.textarea;

            var newValue = command.execute(text, (0, _ReactMdeSelectionHelper.getSelection)(textarea));

            // let's select EVERYTHING and replace with the result of the command.
            // This will cause an 'inconvenience' which is: Ctrl + Z will select the whole
            // text. But this is the LEAST possible inconvenience. We can pretty much live
            // with it. I've tried everything in my reach, including reimplementing the textarea
            // history. That caused more problems than it solved.

            this.refs.textarea.focus();
            (0, _ReactMdeSelectionHelper.setSelection)(this.refs.textarea, 0, this.refs.textarea.value.length);
            document.execCommand("insertText", false, newValue.text);

            (0, _ReactMdeSelectionHelper.setSelection)(this.refs.textarea, newValue.selection[0], newValue.selection[1]);
        }

        /**
         * Renders react-mde
         * @returns
         * @memberOf ReactMde
         */

    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props3 = this.props,
                _props3$value = _props3.value,
                text = _props3$value.text,
                selection = _props3$value.selection,
                onChange = _props3.onChange,
                commands = _props3.commands,
                textareaId = _props3.textareaId,
                textareaName = _props3.textareaName;


            var html = this.converter.makeHtml(text) || '<p>&nbsp</p>';

            var header = null;
            if (commands) {
                header = _react2.default.createElement(
                    'div',
                    { className: 'mde-header' },
                    commands.map(function (cg, i) {
                        return _react2.default.createElement(
                            _HeaderGroup2.default,
                            { key: i },
                            cg.map(function (c, j) {
                                if (c.type == 'dropdown') return _react2.default.createElement(_HeaderItemDropdown2.default, { key: j, icon: c.icon, commands: c.subCommands, onCommand: function onCommand(c) {
                                        return _this2.executeCommand(c);
                                    } });else return _react2.default.createElement(_HeaderItem2.default, { key: j, icon: c.icon, tooltip: c.tooltip, onClick: function onClick() {
                                        return _this2.executeCommand(c);
                                    } });
                            })
                        );
                    })
                );
            }

            return _react2.default.createElement(
                'div',
                { className: 'react-mde' },
                header,
                _react2.default.createElement(
                    'div',
                    { className: 'mde-text' },
                    _react2.default.createElement('textarea', { onChange: this.handleValueChange.bind(this), value: text, ref: 'textarea', id: textareaId, name: textareaId })
                ),
                _react2.default.createElement('div', { className: 'mde-preview', dangerouslySetInnerHTML: { __html: html } }),
                _react2.default.createElement(
                    'div',
                    { className: 'mde-help' },
                    _react2.default.createElement(_MarkdownHelp2.default, null)
                )
            );
        }
    }]);

    return ReactMde;
}(_react.Component);

ReactMde.propTypes = {
    commands: _react2.default.PropTypes.array
};
exports.default = ReactMde;
module.exports = exports['default'];